<?php
/*
#Threshold plugin 2.0c for cacti 8.6c
#
# Copyright 2005 Aurelio DeSimone
# adesimone@ciscoconfigbuilder.com
#
# Use at your own risk.  NO Warranty or Guarantee given.
#
# Some code may have been used from other parts of cacti - copyright of Ian Berry
#
*/

/*
<<<<<< THIS IS THE MAIN THOLD POLLER SCRIPT >>>>>>>
it should run right after the cacti poll is done
*/

//turn on - debug=1 (outputs to $cactibasedir/log/thold.log)
global $debug;
$debug=1;

$no_http_headers = true;

include("../include/config.php");

function logger($element, $threshld, $currentval, $trigger, $triggerct) {
        define_syslog_variables();
        openlog("CactiTholdLog", LOG_PID | LOG_PERROR, LOG_LOCAL0);
        syslog(LOG_WARNING, "$element exceeded $threshld with $currentval at trigger $trigger out of $triggerct");
        }

$db = mysql_connect("$database_hostname", "$database_username", "$database_password");
mysql_select_db("$database_default",$db);
$lookupset = mysql_fetch_array(mysql_query("SELECT * FROM settings WHERE name='path_cactilog'")) or die (mysql_error() );

//the "SERVER_NAME" didn't seem to work in some cases - so we force it to work...
if (isset($_SERVER["SERVER_NAME"])) {
	$hostname = $_SERVER["SERVER_NAME"];
	} else {
	$hostname = exec("hostname");
	}

$cactibasedir=$config["base_path"];

$rootdir="$cactibasedir/thold";
$httpurl="http://$hostname/cacti";
$logfile=$lookupset["value"];
$newlogfile="$cactibasedir/log/cactilog.temp";
$elementcache="$rootdir/state";
//shell_exec("mv $logfile $newlogfile");

// fetch settings
$queryset = mysql_fetch_array(mysql_query("SELECT * FROM tholdset")) or die (mysql_error() );
$emailadd = $queryset["emailadd"];
$logset = $queryset["logset"];
$deadnotify = $queryset["deadnotify"];

//timestamp for last lookup
mysql_query("UPDATE tholdset SET datet=NOW() WHERE id='1'") or die (mysql_error() );

$tholdarray = "SELECT * FROM thold";
$query=mysql_query($tholdarray) or die (mysql_error() );

while($row=mysql_fetch_array($query)) {


$element = $row["description"];
$alertstat = $row["alertstat"];
$elementid = $row["element"];
$threshld = $row["threshold"];
$rra = $row["rra"];
$trigger = $row["trigger"];
$triggerct = $row["triggerct"];

// old school - lame version(2.0b)
//$currentval = shell_exec("grep _$rra.rrd $newlogfile | $cactibasedir/thold/parse.sh");

// more intelligent RRDTOOL-based polling method - contributed by mdw162 - version 2.0c

$rrdtoolpath = read_config_option("path_rrdtool");
$last_time_entry = exec("$rrdtoolpath last $cactibasedir/rra/*_$rra.rrd MAX");
$last_needed = $last_time_entry + 900;
$current_time = time();
$output = exec("$rrdtoolpath fetch $cactibasedir/rra/*_$rra.rrd MAX -s $last_time_entry | grep -vi nan | tail -1 | awk '{print $2}' ");
$currentval = round ($output);


// database-based polling method - version 2.0d
/*

// let's make sure we delete the right dataset at the end of this script
$getstarttime = mysql_fetch_array(mysql_query("SELECT time FROM poller_output LIMIT 1"));
$starttime = $getstarttime["time"];


$grabcurrentdb = mysql_fetch_array(mysql_query("SELECT output FROM poller_output where time='$starttime' and local_data_id='$rra' LIMIT 1"));
$currentoutput = $grabcurrentdb["output"];
*/

$msg = "<a href=$httpurl/graph.php?local_graph_id=$elementid&rra_id=1>$httpurl/graph.php?local_graph_id=$elementid&rra_id=1</a><Br><img src=$httpurl/graph_image.php?local_graph_id=$elementid&rra_id=0&view_type=tree>";

//if ($currentval > $threshld || $last_needed < $current_time) {
if ($currentval > $threshld) {
	if ($alertstat == 1) {
		$newtrigger=$triggerct + 1;
			if ($logset == 1) {
				logger($element, $threshld, $currentval, $trigger, $newtrigger);
				}
		mysql_query("UPDATE thold SET lastread='$currentval',alertstat='1',triggerct='$newtrigger' WHERE rra='$rra'") or die (mysql_error() );
		if ($trigger == $newtrigger) {
			$subject = "$element exceeded threshold of $threshld with $currentval";
			mail($emailadd, $subject, $msg, "Content-Type: text/html\n");
                        }
        } else {
			$newtrigger = $triggerct + 1;
			if ($logset == 1) {
				logger($element, $threshld, $currentval, $trigger, $newtrigger);
				}
			if ($trigger == $newtrigger) {
	                        $subject = "$element exceeded threshold of $threshld with $currentval";
        	                mail($emailadd, $subject, $msg, "Content-Type: text/html\n");
				}
			mysql_query("UPDATE thold SET lastread='$currentval',alertstat='1',triggerct='1' WHERE rra='$rra'") or die (mysql_error() );
                }

	} else {
                if ($alertstat == 1) {
                                if ($logset == 1) {
					logger($element, $threshld, $currentval, $trigger, $triggerct);
                                        }
                        if ($triggerct > $trigger || $triggerct == $trigger) {
                                $subject = "$element fell below threshold of $threshld with $currentval";
                                mail($emailadd, $subject, $msg, "Content-Type: text/html\n");
			}
			mysql_query("UPDATE thold SET lastread='$currentval',alertstat='0',triggerct='0' WHERE rra='$rra'") or die (mysql_error() );
                } else {
			mysql_query("UPDATE thold SET lastread='$currentval',alertstat='0',triggerct='0' WHERE rra='$rra'") or die (mysql_error() );
                }

// debugging outpug
if ($debug == 1) {
	$filename = "$cactibasedir/log/thold.log";
		if (is_writable($filename)) {
   			if (!$handle = fopen($filename, 'a')) {
		        echo "Cannot open file ($filename)";
   			}
		} else {
		   echo "The file $filename is not writable";
		}
	$logdate = date("m-d-y.H:i:s");
	$logout = "$logdate element: $element alertstat: $alertstat elementid: $elementid threshld: $threshld rra: $rra trigger: $trigger triggerct: $triggerct current: $currentval\n";
	fwrite($handle, $logout);
	}
}
}

// bulk delete for dataset
//mysql_query("DELETE FROM poller_output where time='$starttime'");

// should we notify you if there are dead/recovering hosts?
if ($deadnotify == 1) {
$resulta = mysql_query("SELECT id,description,status FROM host WHERE status='1' AND disabled<>'on'") or die (mysql_error() );
$resultb = mysql_query("SELECT id,description,status FROM host WHERE status='2' AND disabled<>'on'") or die (mysql_error() );
$num_rowsa = mysql_num_rows($resulta);
$num_rowsb = mysql_num_rows($resultb);

$subject = "Cacti ($hostname) - Host unreachable report";

$msg = "<table width=100>";

if ($num_rowsa > 0) {
		while ($row = mysql_fetch_array($resulta, MYSQL_ASSOC)) {
		$msg .= "<tr>There are currently $num_rowsa hosts down:</tr>\n\n";
	        $msg .= "<tr><a href='http://$hostname/cacti/host.php?action=edit&id=";
	        $msg .= $row["id"];
        	$msg .= "'>";
	        $msg .= $row["description"];
        	$msg .= "</a></tr>";
        }
}

if ($num_rowsb > 0) {
	while ($rowb = mysql_fetch_array($resultb, MYSQL_ASSOC)) {
		$msg .= "<tr>There are currently $num_rowsb hosts recovering:</tr>\n\n";
	        $msg .= "<tr><a href='http://$hostname/cacti/host.php?action=edit&id=";
	        $msg .= $rowb["id"];
        	$msg .= "'>";
	        $msg .= $rowb["description"];
        	$msg .= "</a></tr>";
        }
}

$msg .= "</table>";

if ($num_rowsa > 0 || $num_rowsb > 0) {
	mail($emailadd, $subject, $msg, "Content-Type: text/html\n");
	}
}

?>
